<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.polco.config;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.IOException;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.util.concurrent.atomic.AtomicReference;<a name="line.37"></a>
<FONT color="green">038</FONT>    <a name="line.38"></a>
<FONT color="green">039</FONT>    import ch.javasoft.math.array.Converter;<a name="line.39"></a>
<FONT color="green">040</FONT>    import ch.javasoft.math.linalg.LinAlgOperations;<a name="line.40"></a>
<FONT color="green">041</FONT>    import ch.javasoft.polco.EqualityPolyhedralCone;<a name="line.41"></a>
<FONT color="green">042</FONT>    import ch.javasoft.polco.InequalityPolyhedralCone;<a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.polco.PolyhedralCone;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.polco.impl.DefaultEqualityCone;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.polco.impl.DefaultInequalityCone;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.polco.impl.DefaultPolyhedralCone;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.polco.transform.TransformHelper;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.polco.transform.TransformedPolyhedralCone;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.polco.xenum.ExtremeRayCallback;<a name="line.49"></a>
<FONT color="green">050</FONT>    import ch.javasoft.polco.xenum.ExtremeRayEvent;<a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.util.numeric.Zero;<a name="line.51"></a>
<FONT color="green">052</FONT>    <a name="line.52"></a>
<FONT color="green">053</FONT>    /**<a name="line.53"></a>
<FONT color="green">054</FONT>     * The &lt;code&gt;TypeConverter&lt;/code&gt; contains methods to convert different type <a name="line.54"></a>
<FONT color="green">055</FONT>     * dependent objects from one number type to another.<a name="line.55"></a>
<FONT color="green">056</FONT>     */<a name="line.56"></a>
<FONT color="green">057</FONT>    public class TypeConverter&lt;IN extends Number, IA, RN extends Number, RA&gt; {<a name="line.57"></a>
<FONT color="green">058</FONT>            private final boolean                                           allowMatrixRowScaling;<a name="line.58"></a>
<FONT color="green">059</FONT>            private final LinAlgOperations&lt;IN, IA&gt;            originalOps;<a name="line.59"></a>
<FONT color="green">060</FONT>            private final LinAlgOperations&lt;RN, RA&gt;            targetOps;<a name="line.60"></a>
<FONT color="green">061</FONT>            private final Converter&lt;IN, IA, RN, RA&gt;           converter;<a name="line.61"></a>
<FONT color="green">062</FONT>            public TypeConverter(LinAlgOperations&lt;IN, IA&gt; originalOps, LinAlgOperations&lt;RN, RA&gt; targetOps, boolean allowMatrixRowScaling) {<a name="line.62"></a>
<FONT color="green">063</FONT>                    this.allowMatrixRowScaling      = allowMatrixRowScaling;<a name="line.63"></a>
<FONT color="green">064</FONT>                    this.originalOps                        = originalOps;<a name="line.64"></a>
<FONT color="green">065</FONT>                    this.targetOps                          = targetOps;<a name="line.65"></a>
<FONT color="green">066</FONT>                    this.converter                          = new Converter&lt;IN, IA, RN, RA&gt;(originalOps.getNumberArrayOperations(), targetOps.getNumberArrayOperations());<a name="line.66"></a>
<FONT color="green">067</FONT>            }<a name="line.67"></a>
<FONT color="green">068</FONT>            public TypeConverter(Arithmetic&lt;IN, IA&gt; originalType, Zero originalZero, Arithmetic&lt;RN, RA&gt; targetType, Zero targetZero, boolean allowMatrixRowScaling) {<a name="line.68"></a>
<FONT color="green">069</FONT>                    this(originalType.getLinAlgOperations(originalZero), targetType.getLinAlgOperations(targetZero), allowMatrixRowScaling);<a name="line.69"></a>
<FONT color="green">070</FONT>            }<a name="line.70"></a>
<FONT color="green">071</FONT>            public Converter&lt;IN, IA, RN, RA&gt; getConverter() {<a name="line.71"></a>
<FONT color="green">072</FONT>                    return converter;<a name="line.72"></a>
<FONT color="green">073</FONT>            }<a name="line.73"></a>
<FONT color="green">074</FONT>            public boolean isIdentityConverter() {<a name="line.74"></a>
<FONT color="green">075</FONT>                    return converter.isIdentityConverter();<a name="line.75"></a>
<FONT color="green">076</FONT>            }<a name="line.76"></a>
<FONT color="green">077</FONT>            @SuppressWarnings("unchecked")<a name="line.77"></a>
<FONT color="green">078</FONT>            public ExtremeRayCallback&lt;RN, RA&gt; convertCallback(final ExtremeRayCallback&lt;IN, IA&gt; original) {<a name="line.78"></a>
<FONT color="green">079</FONT>                    if (isIdentityConverter()) {<a name="line.79"></a>
<FONT color="green">080</FONT>                            return (ExtremeRayCallback&lt;RN, RA&gt;)original;<a name="line.80"></a>
<FONT color="green">081</FONT>                    }<a name="line.81"></a>
<FONT color="green">082</FONT>                    return convertCallbackInternal(original);<a name="line.82"></a>
<FONT color="green">083</FONT>            }<a name="line.83"></a>
<FONT color="green">084</FONT>            private ExtremeRayCallback&lt;RN, RA&gt; convertCallbackInternal(final ExtremeRayCallback&lt;IN, IA&gt; original) {<a name="line.84"></a>
<FONT color="green">085</FONT>                    final TypeConverter&lt;RN, RA, IN, IA&gt; back = new TypeConverter&lt;RN, RA, IN, IA&gt;(targetOps, originalOps, allowMatrixRowScaling);<a name="line.85"></a>
<FONT color="green">086</FONT>                    return new ExtremeRayCallback&lt;RN, RA&gt;() {<a name="line.86"></a>
<FONT color="green">087</FONT>                            final ThreadLocal&lt;ExtremeRayEvent&lt;IN, IA&gt;&gt; convertedEvent   = new ThreadLocal&lt;ExtremeRayEvent&lt;IN,IA&gt;&gt;();<a name="line.87"></a>
<FONT color="green">088</FONT>                            final ThreadLocal&lt;ExtremeRayEvent&lt;RN, RA&gt;&gt; originalEvent    = new ThreadLocal&lt;ExtremeRayEvent&lt;RN,RA&gt;&gt;();<a name="line.88"></a>
<FONT color="green">089</FONT>                            public boolean initialize(ExtremeRayEvent&lt;RN, RA&gt; event) throws IOException {<a name="line.89"></a>
<FONT color="green">090</FONT>                                    final ExtremeRayEvent&lt;IN, IA&gt; cEvent = back.convertEvent(event);<a name="line.90"></a>
<FONT color="green">091</FONT>                                    originalEvent.set(event);<a name="line.91"></a>
<FONT color="green">092</FONT>                                    convertedEvent.set(cEvent);<a name="line.92"></a>
<FONT color="green">093</FONT>                                    return original.initialize(cEvent);<a name="line.93"></a>
<FONT color="green">094</FONT>                            }<a name="line.94"></a>
<FONT color="green">095</FONT>                            public void outputExtremeRay(ExtremeRayEvent&lt;RN,RA&gt; event, long index, RA extremeRay) throws IOException {<a name="line.95"></a>
<FONT color="green">096</FONT>                                    final ExtremeRayEvent&lt;IN, IA&gt; cEvent;<a name="line.96"></a>
<FONT color="green">097</FONT>                                    if (event.equals(originalEvent.get())) {<a name="line.97"></a>
<FONT color="green">098</FONT>                                            cEvent = convertedEvent.get();<a name="line.98"></a>
<FONT color="green">099</FONT>                                    }<a name="line.99"></a>
<FONT color="green">100</FONT>                                    else {<a name="line.100"></a>
<FONT color="green">101</FONT>                                            originalEvent.set(event);<a name="line.101"></a>
<FONT color="green">102</FONT>                                            convertedEvent.set(cEvent = back.convertEvent(event));<a name="line.102"></a>
<FONT color="green">103</FONT>                                    }<a name="line.103"></a>
<FONT color="green">104</FONT>                                    final IA cExtremeRay = back.converter.convertVector(extremeRay, true /*normalize*/, true /*allowScaling*/);<a name="line.104"></a>
<FONT color="green">105</FONT>                                    original.outputExtremeRay(cEvent, index, cExtremeRay);<a name="line.105"></a>
<FONT color="green">106</FONT>                            }<a name="line.106"></a>
<FONT color="green">107</FONT>                            public void terminate(ExtremeRayEvent&lt;RN, RA&gt; event) throws IOException {<a name="line.107"></a>
<FONT color="green">108</FONT>                                    final ExtremeRayEvent&lt;IN, IA&gt; cEvent;<a name="line.108"></a>
<FONT color="green">109</FONT>                                    if (event.equals(originalEvent.get())) {<a name="line.109"></a>
<FONT color="green">110</FONT>                                            cEvent = convertedEvent.get();<a name="line.110"></a>
<FONT color="green">111</FONT>                                    }<a name="line.111"></a>
<FONT color="green">112</FONT>                                    else {<a name="line.112"></a>
<FONT color="green">113</FONT>                                            originalEvent.set(event);<a name="line.113"></a>
<FONT color="green">114</FONT>                                            convertedEvent.set(cEvent = back.convertEvent(event));<a name="line.114"></a>
<FONT color="green">115</FONT>                                    }<a name="line.115"></a>
<FONT color="green">116</FONT>                                    original.terminate(cEvent);<a name="line.116"></a>
<FONT color="green">117</FONT>                                    originalEvent.set(null);<a name="line.117"></a>
<FONT color="green">118</FONT>                                    convertedEvent.set(null);<a name="line.118"></a>
<FONT color="green">119</FONT>                            }<a name="line.119"></a>
<FONT color="green">120</FONT>                    };<a name="line.120"></a>
<FONT color="green">121</FONT>            }<a name="line.121"></a>
<FONT color="green">122</FONT>            @SuppressWarnings("unchecked")<a name="line.122"></a>
<FONT color="green">123</FONT>            public ExtremeRayEvent&lt;RN, RA&gt; convertEvent(final ExtremeRayEvent&lt;IN, IA&gt; original) {<a name="line.123"></a>
<FONT color="green">124</FONT>                    if (isIdentityConverter()) {<a name="line.124"></a>
<FONT color="green">125</FONT>                            return (ExtremeRayEvent&lt;RN, RA&gt;)original;<a name="line.125"></a>
<FONT color="green">126</FONT>                    }<a name="line.126"></a>
<FONT color="green">127</FONT>                    return convertEventInternal(original);          <a name="line.127"></a>
<FONT color="green">128</FONT>            }<a name="line.128"></a>
<FONT color="green">129</FONT>            private ExtremeRayEvent&lt;RN, RA&gt; convertEventInternal(final ExtremeRayEvent&lt;IN, IA&gt; original) {<a name="line.129"></a>
<FONT color="green">130</FONT>                    final PolyhedralCone&lt;RN, RA&gt; converted = convertPolyhedralCone(original.getPolyhedralCone());<a name="line.130"></a>
<FONT color="green">131</FONT>                    return new ExtremeRayEvent&lt;RN, RA&gt;(converted, original.getRayCount());            <a name="line.131"></a>
<FONT color="green">132</FONT>            }<a name="line.132"></a>
<FONT color="green">133</FONT>            @SuppressWarnings("unchecked")<a name="line.133"></a>
<FONT color="green">134</FONT>            public PolyhedralCone&lt;RN, RA&gt; convertPolyhedralCone(final PolyhedralCone&lt;IN, IA&gt; original) {<a name="line.134"></a>
<FONT color="green">135</FONT>                    if (isIdentityConverter()) {<a name="line.135"></a>
<FONT color="green">136</FONT>                            return (PolyhedralCone&lt;RN, RA&gt;)original;<a name="line.136"></a>
<FONT color="green">137</FONT>                    }<a name="line.137"></a>
<FONT color="green">138</FONT>                    return convertPolyhedralConeInternal(original);         <a name="line.138"></a>
<FONT color="green">139</FONT>                    <a name="line.139"></a>
<FONT color="green">140</FONT>            }<a name="line.140"></a>
<FONT color="green">141</FONT>            private PolyhedralCone&lt;RN, RA&gt; convertPolyhedralConeInternal(final PolyhedralCone&lt;IN, IA&gt; original) {<a name="line.141"></a>
<FONT color="green">142</FONT>                    if (original instanceof EqualityPolyhedralCone) {<a name="line.142"></a>
<FONT color="green">143</FONT>                            final EqualityPolyhedralCone&lt;IN, IA&gt; cone = (EqualityPolyhedralCone&lt;IN, IA&gt;)original;<a name="line.143"></a>
<FONT color="green">144</FONT>                            final RA[] convA;<a name="line.144"></a>
<FONT color="green">145</FONT>                            final IA[] origA = cone.getA();<a name="line.145"></a>
<FONT color="green">146</FONT>                            synchronized (origA) {<a name="line.146"></a>
<FONT color="green">147</FONT>                                    convA = convertMatrix(origA, true);<a name="line.147"></a>
<FONT color="green">148</FONT>                            }<a name="line.148"></a>
<FONT color="green">149</FONT>                            if (original instanceof TransformedPolyhedralCone) {<a name="line.149"></a>
<FONT color="green">150</FONT>                                    return createTransformedEqualityCone((TransformedPolyhedralCone&lt;IN, IA&gt;)original, convA);<a name="line.150"></a>
<FONT color="green">151</FONT>                            }<a name="line.151"></a>
<FONT color="green">152</FONT>                            else {<a name="line.152"></a>
<FONT color="green">153</FONT>                                    return new DefaultEqualityCone&lt;RN, RA&gt;(targetOps, convA) {<a name="line.153"></a>
<FONT color="green">154</FONT>                                            @Override<a name="line.154"></a>
<FONT color="green">155</FONT>                                            public int getDimensions() {<a name="line.155"></a>
<FONT color="green">156</FONT>                                                    return original.getDimensions();<a name="line.156"></a>
<FONT color="green">157</FONT>                                            }                                       <a name="line.157"></a>
<FONT color="green">158</FONT>                                    };<a name="line.158"></a>
<FONT color="green">159</FONT>                            }<a name="line.159"></a>
<FONT color="green">160</FONT>                    }<a name="line.160"></a>
<FONT color="green">161</FONT>                    else if (original instanceof InequalityPolyhedralCone) {<a name="line.161"></a>
<FONT color="green">162</FONT>                            final InequalityPolyhedralCone&lt;IN, IA&gt; cone = (InequalityPolyhedralCone&lt;IN, IA&gt;)original;<a name="line.162"></a>
<FONT color="green">163</FONT>                            final RA[] convB;<a name="line.163"></a>
<FONT color="green">164</FONT>                            final IA[] origB = cone.getB();<a name="line.164"></a>
<FONT color="green">165</FONT>                            synchronized (origB) {<a name="line.165"></a>
<FONT color="green">166</FONT>                                    convB = convertMatrix(origB, true);<a name="line.166"></a>
<FONT color="green">167</FONT>                            }<a name="line.167"></a>
<FONT color="green">168</FONT>                            if (original instanceof TransformedPolyhedralCone) {<a name="line.168"></a>
<FONT color="green">169</FONT>                                    return createTransformedInequalityCone((TransformedPolyhedralCone&lt;IN, IA&gt;)original, convB);<a name="line.169"></a>
<FONT color="green">170</FONT>                            }<a name="line.170"></a>
<FONT color="green">171</FONT>                            return new DefaultInequalityCone&lt;RN, RA&gt;(targetOps, convB) {<a name="line.171"></a>
<FONT color="green">172</FONT>                                    @Override<a name="line.172"></a>
<FONT color="green">173</FONT>                                    public int getDimensions() {<a name="line.173"></a>
<FONT color="green">174</FONT>                                            return original.getDimensions();<a name="line.174"></a>
<FONT color="green">175</FONT>                                    }                               <a name="line.175"></a>
<FONT color="green">176</FONT>                            };<a name="line.176"></a>
<FONT color="green">177</FONT>                    }<a name="line.177"></a>
<FONT color="green">178</FONT>                    else {<a name="line.178"></a>
<FONT color="green">179</FONT>                            final RA[] convA;<a name="line.179"></a>
<FONT color="green">180</FONT>                            final RA[] convB;<a name="line.180"></a>
<FONT color="green">181</FONT>                            final IA[] origA = original.getA();<a name="line.181"></a>
<FONT color="green">182</FONT>                            final IA[] origB = original.getB();<a name="line.182"></a>
<FONT color="green">183</FONT>                            synchronized (origA) {<a name="line.183"></a>
<FONT color="green">184</FONT>                                    convA = convertMatrix(origA, true);<a name="line.184"></a>
<FONT color="green">185</FONT>                            }<a name="line.185"></a>
<FONT color="green">186</FONT>                            synchronized (origB) {<a name="line.186"></a>
<FONT color="green">187</FONT>                                    convB = convertMatrix(origB, true);<a name="line.187"></a>
<FONT color="green">188</FONT>                            }<a name="line.188"></a>
<FONT color="green">189</FONT>                            if (original instanceof TransformedPolyhedralCone) {<a name="line.189"></a>
<FONT color="green">190</FONT>                                    return createTransformedPolyhedralCone((TransformedPolyhedralCone&lt;IN, IA&gt;)original, convA, convB);<a name="line.190"></a>
<FONT color="green">191</FONT>                            }<a name="line.191"></a>
<FONT color="green">192</FONT>                            return new DefaultPolyhedralCone&lt;RN, RA&gt;(targetOps, convA, convB) {<a name="line.192"></a>
<FONT color="green">193</FONT>                                    @Override<a name="line.193"></a>
<FONT color="green">194</FONT>                                    public int getDimensions() {<a name="line.194"></a>
<FONT color="green">195</FONT>                                            return original.getDimensions();<a name="line.195"></a>
<FONT color="green">196</FONT>                                    }                               <a name="line.196"></a>
<FONT color="green">197</FONT>                            };<a name="line.197"></a>
<FONT color="green">198</FONT>                    }<a name="line.198"></a>
<FONT color="green">199</FONT>            }<a name="line.199"></a>
<FONT color="green">200</FONT>            <a name="line.200"></a>
<FONT color="green">201</FONT>            private PolyhedralCone&lt;RN, RA&gt; createTransformedEqualityCone(final TransformedPolyhedralCone&lt;IN, IA&gt; original, RA[] mxA) {<a name="line.201"></a>
<FONT color="green">202</FONT>                    final class TransformedEqualityCone extends DefaultEqualityCone&lt;RN, RA&gt; implements TransformedPolyhedralCone&lt;RN, RA&gt; {<a name="line.202"></a>
<FONT color="green">203</FONT>                            private volatile PolyhedralCone&lt;RN, RA&gt; parent;<a name="line.203"></a>
<FONT color="green">204</FONT>                            private volatile AtomicReference&lt;RA[]&gt;    mxTtoOriginal = new AtomicReference&lt;RA[]&gt;();<a name="line.204"></a>
<FONT color="green">205</FONT>                            public TransformedEqualityCone(LinAlgOperations&lt;RN, RA&gt; linAlgOps, RA[] mxA) {<a name="line.205"></a>
<FONT color="green">206</FONT>                                    super(linAlgOps, mxA);<a name="line.206"></a>
<FONT color="green">207</FONT>                            }<a name="line.207"></a>
<FONT color="green">208</FONT>                            public PolyhedralCone&lt;RN, RA&gt; getParentCone() {<a name="line.208"></a>
<FONT color="green">209</FONT>                                    if (parent == null) {<a name="line.209"></a>
<FONT color="green">210</FONT>                                            if (parent == null) {<a name="line.210"></a>
<FONT color="green">211</FONT>                                                    parent = convertPolyhedralCone(original.getParentCone());<a name="line.211"></a>
<FONT color="green">212</FONT>                                            }<a name="line.212"></a>
<FONT color="green">213</FONT>                                    }<a name="line.213"></a>
<FONT color="green">214</FONT>                                    return parent;<a name="line.214"></a>
<FONT color="green">215</FONT>                            }<a name="line.215"></a>
<FONT color="green">216</FONT>                            public PolyhedralCone&lt;RN, RA&gt; getOriginalCone() {<a name="line.216"></a>
<FONT color="green">217</FONT>                                    return TransformHelper.getOriginalCone(this);<a name="line.217"></a>
<FONT color="green">218</FONT>                            }<a name="line.218"></a>
<FONT color="green">219</FONT>                            @Override<a name="line.219"></a>
<FONT color="green">220</FONT>                            public int getDimensions() {<a name="line.220"></a>
<FONT color="green">221</FONT>                                    return original.getDimensions();<a name="line.221"></a>
<FONT color="green">222</FONT>                            }<a name="line.222"></a>
<FONT color="green">223</FONT>                            public RA transformToOriginal(RA x2) {<a name="line.223"></a>
<FONT color="green">224</FONT>                                    if (mxTtoOriginal.get() == null) {<a name="line.224"></a>
<FONT color="green">225</FONT>                                            final IA[] mxTtoOriginalI = TransformHelper.getTransformationMatrixToOriginal(original);<a name="line.225"></a>
<FONT color="green">226</FONT>                                            synchronized (mxTtoOriginalI) {<a name="line.226"></a>
<FONT color="green">227</FONT>                                                    if (mxTtoOriginal.get() == null) {<a name="line.227"></a>
<FONT color="green">228</FONT>                                                            mxTtoOriginal.compareAndSet(null, convertMatrix(mxTtoOriginalI, false));<a name="line.228"></a>
<FONT color="green">229</FONT>                                                    }<a name="line.229"></a>
<FONT color="green">230</FONT>                                            }<a name="line.230"></a>
<FONT color="green">231</FONT>                                    }<a name="line.231"></a>
<FONT color="green">232</FONT>                                    return TransformHelper.transformToOriginal(this, mxTtoOriginal, x2);<a name="line.232"></a>
<FONT color="green">233</FONT>                            }<a name="line.233"></a>
<FONT color="green">234</FONT>                            public RA[] getTransformationMatrixToParent() {<a name="line.234"></a>
<FONT color="green">235</FONT>                                    throw new RuntimeException("unsupported, use transformToOriginal() instead");<a name="line.235"></a>
<FONT color="green">236</FONT>                            }<a name="line.236"></a>
<FONT color="green">237</FONT>                    }<a name="line.237"></a>
<FONT color="green">238</FONT>                    return new TransformedEqualityCone(targetOps, mxA);<a name="line.238"></a>
<FONT color="green">239</FONT>            }<a name="line.239"></a>
<FONT color="green">240</FONT>            private PolyhedralCone&lt;RN, RA&gt; createTransformedInequalityCone(final TransformedPolyhedralCone&lt;IN, IA&gt; original, RA[] mxB) {<a name="line.240"></a>
<FONT color="green">241</FONT>                    final class TransformedEqualityCone extends DefaultInequalityCone&lt;RN, RA&gt; implements TransformedPolyhedralCone&lt;RN, RA&gt; {<a name="line.241"></a>
<FONT color="green">242</FONT>                            private volatile PolyhedralCone&lt;RN, RA&gt; parent;<a name="line.242"></a>
<FONT color="green">243</FONT>                            private volatile AtomicReference&lt;RA[]&gt;    mxTtoOriginal = new AtomicReference&lt;RA[]&gt;();<a name="line.243"></a>
<FONT color="green">244</FONT>                            public TransformedEqualityCone(LinAlgOperations&lt;RN, RA&gt; linAlgOps, RA[] mxB) {<a name="line.244"></a>
<FONT color="green">245</FONT>                                    super(linAlgOps, mxB);<a name="line.245"></a>
<FONT color="green">246</FONT>                            }<a name="line.246"></a>
<FONT color="green">247</FONT>                            public PolyhedralCone&lt;RN, RA&gt; getParentCone() {<a name="line.247"></a>
<FONT color="green">248</FONT>                                    if (parent == null) {<a name="line.248"></a>
<FONT color="green">249</FONT>                                            if (parent == null) {<a name="line.249"></a>
<FONT color="green">250</FONT>                                                    parent = convertPolyhedralCone(original.getParentCone());<a name="line.250"></a>
<FONT color="green">251</FONT>                                            }<a name="line.251"></a>
<FONT color="green">252</FONT>                                    }<a name="line.252"></a>
<FONT color="green">253</FONT>                                    return parent;<a name="line.253"></a>
<FONT color="green">254</FONT>                            }<a name="line.254"></a>
<FONT color="green">255</FONT>                            public PolyhedralCone&lt;RN, RA&gt; getOriginalCone() {<a name="line.255"></a>
<FONT color="green">256</FONT>                                    return TransformHelper.getOriginalCone(this);<a name="line.256"></a>
<FONT color="green">257</FONT>                            }<a name="line.257"></a>
<FONT color="green">258</FONT>                            @Override<a name="line.258"></a>
<FONT color="green">259</FONT>                            public int getDimensions() {<a name="line.259"></a>
<FONT color="green">260</FONT>                                    return original.getDimensions();<a name="line.260"></a>
<FONT color="green">261</FONT>                            }<a name="line.261"></a>
<FONT color="green">262</FONT>                            public RA transformToOriginal(RA x2) {<a name="line.262"></a>
<FONT color="green">263</FONT>                                    if (mxTtoOriginal.get() == null) {<a name="line.263"></a>
<FONT color="green">264</FONT>                                            final IA[] mxTtoOriginalI = TransformHelper.getTransformationMatrixToOriginal(original);<a name="line.264"></a>
<FONT color="green">265</FONT>                                            synchronized (mxTtoOriginalI) {<a name="line.265"></a>
<FONT color="green">266</FONT>                                                    if (mxTtoOriginal.get() == null) {<a name="line.266"></a>
<FONT color="green">267</FONT>                                                            mxTtoOriginal.compareAndSet(null, convertMatrix(mxTtoOriginalI, false));<a name="line.267"></a>
<FONT color="green">268</FONT>                                                    }<a name="line.268"></a>
<FONT color="green">269</FONT>                                            }<a name="line.269"></a>
<FONT color="green">270</FONT>                                    }<a name="line.270"></a>
<FONT color="green">271</FONT>                                    return TransformHelper.transformToOriginal(this, mxTtoOriginal, x2);<a name="line.271"></a>
<FONT color="green">272</FONT>                            }<a name="line.272"></a>
<FONT color="green">273</FONT>                            public RA[] getTransformationMatrixToParent() {<a name="line.273"></a>
<FONT color="green">274</FONT>                                    throw new RuntimeException("unsupported, use transformToOriginal() instead");<a name="line.274"></a>
<FONT color="green">275</FONT>                            }<a name="line.275"></a>
<FONT color="green">276</FONT>                    }<a name="line.276"></a>
<FONT color="green">277</FONT>                    return new TransformedEqualityCone(targetOps, mxB);<a name="line.277"></a>
<FONT color="green">278</FONT>            }<a name="line.278"></a>
<FONT color="green">279</FONT>            private PolyhedralCone&lt;RN, RA&gt; createTransformedPolyhedralCone(final TransformedPolyhedralCone&lt;IN, IA&gt; original, RA[] mxA, RA[] mxB) {<a name="line.279"></a>
<FONT color="green">280</FONT>                    final class TransformedCone extends DefaultPolyhedralCone&lt;RN, RA&gt; implements TransformedPolyhedralCone&lt;RN, RA&gt; {<a name="line.280"></a>
<FONT color="green">281</FONT>                            private volatile PolyhedralCone&lt;RN, RA&gt; parent;<a name="line.281"></a>
<FONT color="green">282</FONT>                            private volatile AtomicReference&lt;RA[]&gt;    mxTtoOriginal = new AtomicReference&lt;RA[]&gt;();<a name="line.282"></a>
<FONT color="green">283</FONT>                            public TransformedCone(LinAlgOperations&lt;RN, RA&gt; linAlgOps, RA[] mxA, RA[] mxB) {<a name="line.283"></a>
<FONT color="green">284</FONT>                                    super(linAlgOps, mxA, mxB);<a name="line.284"></a>
<FONT color="green">285</FONT>                            }<a name="line.285"></a>
<FONT color="green">286</FONT>                            public PolyhedralCone&lt;RN, RA&gt; getParentCone() {<a name="line.286"></a>
<FONT color="green">287</FONT>                                    if (parent == null) {<a name="line.287"></a>
<FONT color="green">288</FONT>                                            if (parent == null) {<a name="line.288"></a>
<FONT color="green">289</FONT>                                                    parent = convertPolyhedralCone(original.getParentCone());<a name="line.289"></a>
<FONT color="green">290</FONT>                                            }<a name="line.290"></a>
<FONT color="green">291</FONT>                                    }<a name="line.291"></a>
<FONT color="green">292</FONT>                                    return parent;<a name="line.292"></a>
<FONT color="green">293</FONT>                            }<a name="line.293"></a>
<FONT color="green">294</FONT>                            public PolyhedralCone&lt;RN, RA&gt; getOriginalCone() {<a name="line.294"></a>
<FONT color="green">295</FONT>                                    return TransformHelper.getOriginalCone(this);<a name="line.295"></a>
<FONT color="green">296</FONT>                            }<a name="line.296"></a>
<FONT color="green">297</FONT>                            public RA transformToOriginal(RA x2) {<a name="line.297"></a>
<FONT color="green">298</FONT>                                    if (mxTtoOriginal.get() == null) {<a name="line.298"></a>
<FONT color="green">299</FONT>                                            final IA[] mxTtoOriginalI = TransformHelper.getTransformationMatrixToOriginal(original);<a name="line.299"></a>
<FONT color="green">300</FONT>                                            synchronized (mxTtoOriginalI) {<a name="line.300"></a>
<FONT color="green">301</FONT>                                                    if (mxTtoOriginal.get() == null) {<a name="line.301"></a>
<FONT color="green">302</FONT>                                                            mxTtoOriginal.compareAndSet(null, convertMatrix(mxTtoOriginalI, false));<a name="line.302"></a>
<FONT color="green">303</FONT>                                                    }<a name="line.303"></a>
<FONT color="green">304</FONT>                                            }<a name="line.304"></a>
<FONT color="green">305</FONT>                                    }<a name="line.305"></a>
<FONT color="green">306</FONT>                                    return TransformHelper.transformToOriginal(this, mxTtoOriginal, x2);<a name="line.306"></a>
<FONT color="green">307</FONT>                            }<a name="line.307"></a>
<FONT color="green">308</FONT>                            public RA[] getTransformationMatrixToParent() {<a name="line.308"></a>
<FONT color="green">309</FONT>                                    throw new RuntimeException("unsupported, use transformToOriginal() instead");<a name="line.309"></a>
<FONT color="green">310</FONT>                            }<a name="line.310"></a>
<FONT color="green">311</FONT>                    }<a name="line.311"></a>
<FONT color="green">312</FONT>                    return new TransformedCone(targetOps, mxA, mxB);<a name="line.312"></a>
<FONT color="green">313</FONT>            }<a name="line.313"></a>
<FONT color="green">314</FONT>            <a name="line.314"></a>
<FONT color="green">315</FONT>            private RA[] convertMatrix(IA[] original, boolean allowRowScaling) {<a name="line.315"></a>
<FONT color="green">316</FONT>                    try {<a name="line.316"></a>
<FONT color="green">317</FONT>                            return converter.convertMatrix(original);<a name="line.317"></a>
<FONT color="green">318</FONT>                    }<a name="line.318"></a>
<FONT color="green">319</FONT>                    catch (ArithmeticException e) {<a name="line.319"></a>
<FONT color="green">320</FONT>                            return converter.convertMatrix(original, true, allowRowScaling &amp;&amp; allowMatrixRowScaling, false, true);                  <a name="line.320"></a>
<FONT color="green">321</FONT>                    }<a name="line.321"></a>
<FONT color="green">322</FONT>            }<a name="line.322"></a>
<FONT color="green">323</FONT>            <a name="line.323"></a>
<FONT color="green">324</FONT>    }<a name="line.324"></a>




























































</PRE>
</BODY>
</HTML>
